(** Tools from the Coq's extraction *)

(** Type of pair *)
type ('a, 'b) prod =
  | Pair of 'a * 'b

(** First projection *)
let fst = function
  | Pair (x, y) -> x

(** Second projection *)
let snd = function
  | Pair (x, y) -> y

(** Identity function, from Coq's extraction *)
let sumbool_of_bool = function
  | true -> true
  | false -> false 

(** Identity function, from Coq's extraction *)  
let option_dec = function
  | Some t -> Some t
  | None -> None

