type positive = XI of positive | XO of positive | XH

type z = ZERO | POS of positive | NEG of positive

type entier = Nul | Pos of positive

type relation = EGAL | INFERIEUR | SUPERIEUR

val zero_suivi_de : entier -> entier
val un_suivi_de : entier -> entier 
val double_moins_un : positive -> positive 
val double_moins_deux : positive -> entier 
val sub_pos : positive -> positive -> entier 
val sub_neg : positive -> positive -> entier 
val compare : positive -> positive -> relation -> relation 
val dcompare_inf : relation -> bool option 
val add_un : positive -> positive 
val add : positive -> positive -> positive 
val add_carry : positive -> positive -> positive 
val times1 : positive -> ('a -> positive) -> 'a -> positive 
val op : relation -> relation 
val zcompare : z -> z -> relation 
val zcompare_rec :
  z -> z -> (unit -> 'a) -> (unit -> 'a) -> (unit -> 'a) -> 'a 
val z_le_dec : z -> z -> bool 
val z_lt_dec : z -> z -> bool 
val z_eq_dec : z -> z -> bool 
val z_ge_dec : z -> z -> bool 
val z_gt_dec : z -> z -> bool 
val zplus : z -> z -> z 
val zopp : z -> z 
val zminus : z -> z -> z 
val zmult : z -> z -> z 
val zgt_bool : z -> z -> bool 
val zge_bool : z -> z -> bool 
val zdiv_eucl_POS : positive -> z -> (z, z) Tools.prod 
val zdiv_eucl : z -> z -> (z, z) Tools.prod 
val zdiv : z -> z -> z 
val zmod : z -> z -> z 
val iter_pos : positive -> ('a -> 'a) -> 'a -> 'a 
val zpower_pos : z -> positive -> z 
val zpower : z -> z -> z 
val zabs : z -> z
val positive_to_int : positive -> int -> int 
val z_to_int : z -> int 
val int_to_positive : int -> positive 
val int_to_z : int -> z
