(**  This module is for the extraction of the library. We also give some option to have
nice extracted programs. *)

Require Bsml.
Require Bsmlutils.
Require Bsmlbases.
Require Bsmlcomm.
Require PolyList.

Require Export Bsml.

(** ** To have nice extracted programs *)
Extract Constant bsp_p    => "bsp_p".
Extract Constant mkpar    => "mkpar".
Extract Constant apply    => "apply".
Extract Constant ifat     => "ifat".
Extract Constant put      => "put".
Extract Constant super    => "super".
Extract Constant bsp_FAIL => "failwith \"BSP_FAIL\"".

Extract Inductive sumbool => bool [true false].
Extract Inductive bool    => bool [true false].
Extract Inductive unit    => unit [ "()" ].
Extract Inductive sumor   => option [Some None].

(** ** To have extracted programs like in the Bsmllib *)

Extraction NoInline mkpar apply put super ifat.

Extraction NoInline map fold_left app fst snd mklist id compose option_dec is_Some 
                    Zlength Znth from_to from_to2 filtermap to_list.

Extraction NoInline replicate parfun parfun2 parfun3 parfun4 
                    apply2 apply3 apply4 this last none within_bound 
	            noSome hd tl procs pair_of_par par_of_pair 
	            mask noSome_vect tl_hd_vect no_some_in_list_vect
	            get_one_tmp get_one get_list_tmp get_list 
		    bsml_print parprint inbounds mix.

Extraction NoInline shift_tmp shift shift_left shift_right 
                    totex_tmp totex total_exchange bcast_direct_tmp bcast_direct
		    scatter_tmp scatter gather procs_lists_gather gather_list
	            procs_lists scan_direct_tmp1 scan_direct fold_left_vec.


(** ** Extraction of the libraries *)

Extraction "bsmlutils.ml" mklist id compose option_dec is_Some 
                          Zlength Znth from_to from_to2 filtermap to_list.


Extraction "bsmlbase.ml" replicate parfun parfun2 parfun3 parfun4 
                         apply2 apply3 apply4 this last none within_bound 
			 noSome hd tl procs pair_of_par par_of_pair 
			 mask noSome_vect tl_hd_vect no_some_in_list_vect
			 get_one get_list bsml_print parprint inbounds mix.
			  

Extraction "bsmlcomm.ml" shift shift_left shift_right totex total_exchange 
                         bcast_direct scatter gather procs_lists_gather gather_list
			 procs_lists scan_direct fold_left_vec.
