(* ************************************************************************** *)
(* ************************** Decidabilite de mask ************************** *)
(* ************************************************************************** *)

Require Bsml.
Require Export Bsml.

Section mask_is_decidable.


Definition mask :=[T:Set][c:Z->bool][X:(Vector T)][Y:(Vector T)]
(apply T T (apply T (T->T) (mkpar (T->T->T) [j:Z]
 if (sumbool_of_bool  (c j)) then [H1] ([x:T][y:T]x) else [H2] ([x:T][y:T]y)) X) Y).


Lemma mask_tmp1:(T:Set)(c:(Z->bool))(f,g:(Z->T))(i:Z) (H_i:`0<=i<(bsp_p tt)`)
(at T (mkpar T ([j:Z]  if (sumbool_of_bool (c j)) then [H1] (f j) 
                          else  [H2] (g j) )) i H_i) = (if (sumbool_of_bool (c i)) then [H1] (f i) else [H2] (g i)).
Intros.
Rewrite mkpar_def; Auto.
Qed.


Lemma mask_tmp2: (T:Set)(c:(Z->bool))(f,g:(Z->T))(i:Z) (H_i:`0<=i<(bsp_p tt)`) 
(at T (mask T c (mkpar T f) (mkpar T g)) i H_i)=( if (sumbool_of_bool (c i)) then [H1] (f i) 
                                                  else [H2] (g i) ).
Intros.
Unfold mask.
Rewrite apply_def; Auto.
Rewrite apply_def; Auto.
Rewrite mkpar_def; Auto.
Case (sumbool_of_bool (c i));Auto.
Qed.
	 
Lemma mask_is_composition_mkpar:(T:Set)(c:(Z->bool))(f,g:Z->T)(i:Z) (H_i:`0<=i<(bsp_p tt)`)
(at T (mask T c (mkpar T f) (mkpar T g)) i H_i) 
= 
(at T (mkpar T ([j:Z] if (sumbool_of_bool (c j)) then [H1] (f j) else [H2] (g j) )) i H_i).
Intros.
Rewrite (mask_tmp2 T c f g i H_i).
Rewrite (mask_tmp1 T c f g i H_i).
Reflexivity.
Qed.


Lemma mask_is_composition_apply:(T:Set)(c:(Z->bool))(f,g:Z->T->T)(f',g':Z->T)(i:Z) (H_i:`0<=i<(bsp_p tt)`)
(at T (mask T c (apply T T (mkpar (T->T) f) (mkpar T f')) 
                (apply T T (mkpar (T->T) g) (mkpar T g'))) i H_i)
=
(at T (apply T T (mask (T->T) c (mkpar (T->T) f) (mkpar (T->T) g)) (mask T c (mkpar T f') (mkpar T g'))) i H_i).

Intros.
Rewrite apply_def; Auto.
Rewrite (mask_is_composition_mkpar T c f' g' i H_i).
Rewrite (mask_is_composition_mkpar T->T c f g i H_i).
Rewrite mkpar_def; Auto.
Rewrite mkpar_def; Auto.
Unfold mask.
Rewrite apply_def; Auto.
Rewrite apply_def; Auto.
Rewrite mkpar_def; Auto.
Rewrite apply_def; Auto.
Rewrite apply_def; Auto.
Rewrite mkpar_def; Auto.
Rewrite mkpar_def; Auto.
Rewrite mkpar_def; Auto.
Rewrite mkpar_def; Auto.
Case (sumbool_of_bool (c i));Auto.
Qed.

End mask_is_decidable.
